/**********************************************************************************
 * Copyright 2010 Christoph Pflaum 
 * 		Department Informatik Lehrstuhl 10 - Systemsimulation
 *		Friedrich-Alexander Universität Erlangen-Nürnberg
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **********************************************************************************/

//==============================================================================
//
//  $Id: CT_Manip_ET.C,v 1.9 2006/07/14 10:51:29 jochen Exp $
//
//==============================================================================
template <class A>
void 
 print(const A& a) 
    {
      std::cerr << std::endl; 
      a.print(std::cerr); 
      std::cerr << std::endl;
    }
//-----------------------------------------------------------------------------
// Constructor functions to build the corresponding expression objects!
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
  template <class T>
  inline VertexVector<T> 
   vec(const T(&d))
     {
       return VertexVector<T>(d);
     }
//-----------------------------------------------------------------------------
  template <class T>
  inline FUNC1_<T> 
   func(const typename FunctionInterfaces<T>::functionInterfaceOne& f_)
     {
       return FUNC1_<T>(f_);
     }
//-----------------------------------------------------------------------------
  template <class T>
  inline FUNC2_<T> 
   func(const typename FunctionInterfaces<T>::functionInterfaceTwo& f_)
     { 
       return FUNC2_<T>(f_);
     }
//-----------------------------------------------------------------------------
/*  diese Funktionen gehen nicht, deswegen die Verbesserung unten!!
 template <class T>
 inline FUNC3_<T> 
  func(const typename FunctionInterfaces<T>::functionInterfaceThree& f_)
    {
      return FUNC3_<T>(f_);
    }
*/
//-----------------------------------------------------------------------------
 template <class T>
 inline FUNC3_<T> 
  function3Colsamm(T (*f_)(T,T,T))
    {
      return FUNC3_<double>(f_);
    }
    
//-----------------------------------------------------------------------------
 template <class A> 
 inline Conjugate<A> 
  conj(const BasisFunctionExpr<A>& a) 
     {
       return Conjugate<A>(static_cast<const A&>(a));
     }
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
 template <class B> 
 inline CAdd_<int,B>
 operator + (const int&a, const BasisFunctionExpr<B>& b)
    {
      return CAdd_<int,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class B> 
 inline CAdd_<float,B>
 operator + (const float&a, const BasisFunctionExpr<B>& b)
    {
      return CAdd_<float,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class B> 
 inline CAdd_<double,B>
 operator + (const double&a, const BasisFunctionExpr<B>& b)
    {
      return CAdd_<double,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <typename TYPE, class B> 
 inline CAdd_<typename std::complex<TYPE>,B>
 operator + (const typename std::complex<TYPE>&a, const BasisFunctionExpr<B>& b)
    {
      return CAdd_<typename std::complex<TYPE>,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class B> 
 inline CAdd_<int,B>
 operator + (const BasisFunctionExpr<B>& b, const int&a)
    {
      return CAdd_<int,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class B> 
 inline CAdd_<float,B>
 operator + (const BasisFunctionExpr<B>& b, const float&a)
    {
      return CAdd_<float,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class B> 
 inline CAdd_<double,B>
 operator + (const BasisFunctionExpr<B>& b, const double&a)
    {
      return CAdd_<double,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class TYPE, class B> 
 inline CAdd_<typename std::complex<TYPE>,B>
 operator + (const BasisFunctionExpr<B>& b, const typename std::complex<TYPE>&a)
    {
      return CAdd_<typename std::complex<TYPE>,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class A, class B> inline Add_<A,B>
 operator + (const BasisFunctionExpr<A>& a, const BasisFunctionExpr<B>& b)
    {
      return Add_<A,B>(static_cast<const A&>(a),static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
 template <class B> inline CSub_<int,B>
 operator - (const int& a, const BasisFunctionExpr<B>& b)
    {
      return CSub_<int,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class B> inline CSub_<float,B>
 operator - (const float& a, const BasisFunctionExpr<B>& b)
    {
      return CSub_<float,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class B> inline CSub_<double,B>
 operator - (const double& a, const BasisFunctionExpr<B>& b)
    {
      return CSub_<double,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class TYPE, class B> inline CSub_<typename std::complex<TYPE>,B>
 operator - (const typename std::complex<TYPE>& a, const BasisFunctionExpr<B>& b)
    {
      return CSub_<typename std::complex<TYPE>,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class B> inline CAdd_<int,B>
 operator - (const BasisFunctionExpr<B>& b, const int& a)
    {
      return CAdd_<int,B>(-a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class B> inline CAdd_<float,B>
 operator - (const BasisFunctionExpr<B>& b, const float& a)
    {
      return CAdd_<float,B>(-a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class B> inline CAdd_<double,B>
 operator - (const BasisFunctionExpr<B>& b, const double& a)
    {
      return CAdd_<double,B>(-a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class TYPE, class B> inline CAdd_<typename std::complex<TYPE>,B>
 operator - (const BasisFunctionExpr<B>& b, const typename std::complex<TYPE>& a)
    {
      return CAdd_<typename std::complex<TYPE>,B>(-a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class A, class B> inline Sub_<A,B>
 operator - (const BasisFunctionExpr<A>& a, const BasisFunctionExpr<B>& b)
    {
      return Sub_<A,B>(static_cast<const A&>(a),static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class A> inline Min_<A>
 operator - (const BasisFunctionExpr<A>& a)
    {
      return Min_<A>(static_cast<const A&>(a));
    }
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
 template <class B> 
  inline CMult_<int,B>
 operator * (const int& a, const BasisFunctionExpr<B>& b)
    { 
      return CMult_<int,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class B> 
  inline CMult_<float,B>
 operator * (const float& a, const BasisFunctionExpr<B>& b)
    { 
      return CMult_<float,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class B> 
  inline CMult_<double,B>
 operator * (const double& a, const BasisFunctionExpr<B>& b)
    { 
      return CMult_<double,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class TYPE, class B> 
  inline CMult_<typename std::complex<TYPE>,B>
 operator * (const typename std::complex<TYPE>& a, const BasisFunctionExpr<B>& b)
    { 
      return CMult_<typename std::complex<TYPE>,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class B> 
  inline CMult_<int,B>
 operator * (const BasisFunctionExpr<B>& b, const int& a)
    { 
      return CMult_<int,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class B> 
  inline CMult_<float,B>
 operator * (const BasisFunctionExpr<B>& b, const float& a)
    { 
      return CMult_<float,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class B> 
  inline CMult_<double,B>
 operator * (const BasisFunctionExpr<B>& b, const double& a)
    { 
      return CMult_<double,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <typename TYPE, class B> 
  inline CMult_<typename std::complex<TYPE>,B>
 operator * (const BasisFunctionExpr<B>& b, const typename std::complex<TYPE>& a)
    { 
      return CMult_<typename std::complex<TYPE>,B>(a,static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class A, class B>
  inline Mult_<A,B>
 operator * (const BasisFunctionExpr<A>& a, const BasisFunctionExpr<B>& b)
    { 
      return Mult_<A,B>(static_cast<const A&>(a),static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class A, class B> inline Div_<A,B>
 operator / (const BasisFunctionExpr<A>& a, const BasisFunctionExpr<B>& b)
    { 
      return Div_<A,B>(static_cast<const A&>(a),static_cast<const B&>(b));
    }
//-----------------------------------------------------------------------------
 template <class A> 
 inline SQRT_<A>
  Sqrt (const BasisFunctionExpr<A>& a)
     { 
       return SQRT_<A>(static_cast<const A&>(a));
     }
//-----------------------------------------------------------------------------
 template <class A, typename eTYPE> 
 inline POW_<A,eTYPE>
  Pow (const BasisFunctionExpr<A>& a, eTYPE exponent)
     { 
       return POW_<A,eTYPE>(static_cast<const A&>(a),exponent);
     }
//-----------------------------------------------------------------------------
 template <class A> 
 inline EXP_<A>
  Exp(const BasisFunctionExpr<A>& a)
     { 
       return EXP_<A>(static_cast<const A&>(a));
     }
//-----------------------------------------------------------------------------
 template<class A> 
 inline Deri_<A,dx> 
  d_dx(const BasisFunctionExpr<A>& a)
      {
        return Deri_<A,dx>(static_cast<const A&>(a));
      }
//-----------------------------------------------------------------------------
 template<class A> 
 inline Deri_<A,dy>
  d_dy(const BasisFunctionExpr<A>& a)
      {
        return Deri_<A,dy>(static_cast<const A&>(a));
      }
//-----------------------------------------------------------------------------
 template<class A> 
 inline Deri_<A,dz> 
  d_dz(const BasisFunctionExpr<A>& a)
      {
        return Deri_<A,dz>(static_cast<const A&>(a));
      }
//-----------------------------------------------------------------------------
/* A vector is a type list of its components, namely a vector of two  
 * components or a component and vector (which is a component itself)!
 * The evaluation of the operator '&' is from left to right (hopefully),
 * and thereby, we build a template type of the structure
 *   VECTOR<VECTOR<VECTOR<....>,.>,.> 
 * This means, we can only access the VECTOR from the end to the top! 
 * A vector (so far) is always a line or a column, not differentiated 
 * between them! 
*/
//-----------------------------------------------------------------------------
template <class A, class B>
void
VECTOR<A,B>::print(std::ostream &os)const
   { 
#if 1
      a.print(os); 
      os << "\033[44m" << " & " << "\033[m" /*<< std::endl*/;  
      b.print(os);
#else
      os << "VECTOR < " ;  
      a.print(os); 
      os << " , "; 
      b.print(os); 
      os << " > ";
#endif
   }
#if 1
//-----------------------------------------------------------------------------
template <class A, class B>
template<class Element, unsigned int iterLength>
typename Element::TYPE
VECTOR<A,B>::evalLastComponent(const Element& element, const int (&iterator)[iterLength]) const
   {
      return b.eval(element,iterator);
   }
//-----------------------------------------------------------------------------
template <class A1, class A2, class B>
template<class Element, unsigned int iterLength>
typename Element::TYPE
VECTOR<VECTOR<A1,A2>,B>::evalLastComponent(const Element& element, const int (&iterator)[iterLength]) const
   {
      return b.eval(element,iterator);
   }
//-----------------------------------------------------------------------------
template <class A, class B>
VECTOR<A,B> 
operator &(const BasisFunctionExpr<A>& a, const BasisFunctionExpr<B>& b)
   {
     return VECTOR<A,B>(static_cast<const A&>(a),static_cast<const B&>(b));
   }
#endif
//-----------------------------------------------------------------------------
#if 1
template <class A, class B>
VECTOR<A,B> 
operator &(const BasisFunctionVectorExpr<A>& a, const BasisFunctionExpr<B>& b)
   {
     return VECTOR<A,B>(static_cast<const A&>(a),static_cast<const B&>(b));
   }
#endif
// ----------------------------------------------------------------------------
#if 1
 inline VECTOR<VECTOR< NormalComponent<0>,NormalComponent<1> >, NormalComponent<2> >
  N() 
     { 
       return NormalComponent<0>() & NormalComponent<1>() & NormalComponent<2>();
     }
// ----------------------------------------------------------------------------
 inline VECTOR<VECTOR< UnitNormalComponent<0>,UnitNormalComponent<1> >, UnitNormalComponent<2> >
  N_Unit() 
     { 
       return UnitNormalComponent<0> () & UnitNormalComponent<1>() & UnitNormalComponent<2>();
     }
#endif
// ----------------------------------------------------------------------------
template<class A, class B, class Element, unsigned int iterLength>
inline typename Element::TYPE 
 evaluate(const BasisFunctionVectorExpr<A>& a, const BasisFunctionVectorExpr<B>& b,
          const Element& element, const int (&iterator)[iterLength]) 
   {
     return static_cast<const A&>(a).evalLastComponent(element,iterator) * static_cast<const B&>(b).evalLastComponent(element,iterator) + 
            evaluate(static_cast<const A&>(a).getHeadOfVector(),static_cast<const B&>(b).getHeadOfVector(),element,iterator); 
   }
//-----------------------------------------------------------------------------
template<class A, class B, class Element, unsigned int iterLength>
inline typename Element::TYPE 
 evaluate(const BasisFunctionExpr<A>& a, const BasisFunctionExpr<B>& b,
          const Element& element, const int (&iterator)[iterLength]) 
   {
     return static_cast<const A&>(a).eval(element,iterator) * static_cast<const B&>(b).eval(element,iterator);
   }
//-----------------------------------------------------------------------------

/* Concluding comments
 * At this point there is still more to introduce. A compile time data structure
 * which holds tensor data. Therefore we would need an additional operator to be 
 * overloaded, whicht has less priority than operator '&'. 
*/

//==============================================================================

