/**********************************************************************************
 * Copyright 2010 Christoph Pflaum 
 * 		Department Informatik Lehrstuhl 10 - Systemsimulation
 *		Friedrich-Alexander Universität Erlangen-Nürnberg
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **********************************************************************************/

//==============================================================================
//
//  $Id: Elements.h,v 1.54 2006/07/14 10:51:30 jochen Exp $
//
//==============================================================================
//-----------------------------------------------------------------------------
namespace ELEMENTS
   {
    //-----------------------------------------------------------------------------
    // Defining the mappings ...
    //-----------------------------------------------------------------------------
/* Define_Element_Transformation cannot be used on win32 because it uses
 * typeof (see Domain.h). Luckily typeof can be worked around by yanking the
 * type from gdb. Go to the untypeof directory, make and gdb test.o
 * The command "info types" will reveal the type of the typedefs which then
 * just needs to be pasted into the declarations below.
 * make -D_WIN32 to check for compile errors.
 */
#ifndef _WIN32
    Define_Element_Transformation
            (   P_0() +
              ( P_1() - P_0() ) * _U() +
                ( P_3() - P_0() + (P_0() - P_1() + P_2() - P_3() )*_U() ) *_V() +
                ( ( P_4() - P_0()) + (P_0() - P_1() - P_4() + P_5() )*_U() +
                    ( P_0()- P_3() - P_4() + P_7() +
                        ( P_1()-P_0()-P_2()+P_3()+P_4()-P_5()+P_6()-P_7() )*
                                                _U()
                    ) *_V() 
                ) * _W()
            )
            Hexahedron_Transformation;
#else
     typedef VertexAdd<VertexAdd<VertexAdd<Vertex_<0>, VertexPolynomialProduct<VertexSub<Vertex_<1>, Vertex_<0> >, PolynomialXForVertexExpr<1> > >, VertexPolynomialProduct<VertexAdd<VertexSub<Vertex_<3>, Vertex_<0> >, VertexPolynomialProduct<VertexSub<VertexAdd<VertexSub<Vertex_<0>, Vertex_<1> >, Vertex_<2> >, Vertex_<3> >, PolynomialXForVertexExpr<1> > >, PolynomialYForVertexExpr<1> > >,VertexPolynomialProduct<VertexAdd<VertexAdd<VertexSub<Vertex_<4>, Vertex_<0> >, VertexPolynomialProduct<VertexAdd<VertexSub<VertexSub<Vertex_<0>, Vertex_<1> >, Vertex_<4> >, Vertex_<5> >, PolynomialXForVertexExpr<1> > >, VertexPolynomialProduct<VertexAdd<VertexAdd<VertexSub<VertexSub<Vertex_<0>, Vertex_<3> >, Vertex_<4> >, Vertex_<7> >, VertexPolynomialProduct<VertexSub<VertexAdd<VertexSub<VertexAdd<VertexAdd<VertexSub<VertexSub<Vertex_<1>, Vertex_<0> >, Vertex_<2> >, Vertex_<3> >, Vertex_<4> >, Vertex_<5> >, Vertex_<6> >, Vertex_<7> >, PolynomialXForVertexExpr<1> > >, PolynomialYForVertexExpr<1> > >, PolynomialZForVertexExpr<1> > > 
            Hexahedron_Transformation;
#endif /* _WIN32 */    
    //-----------------------------------------------------------------------------
#ifndef _WIN32
     Define_Element_Transformation
            (   P_0() +
              ( P_1() - P_0() ) * _U() +
              ( P_2() - P_0() + (P_0() - P_1() + P_3() - P_2() )*_U() ) *_V() +
              ( ( P_4() - P_0()) + (P_0() - P_1() - P_4() + P_5() )*_U() +
                ( P_0()- P_2() - P_4() + P_6() +
                  ( P_1()-P_0()-P_3()+P_2()+P_4()-P_5()+P_7()-P_6() )*
                                                _U() )*_V() )*_W()
            )
              Hexahedron_Transformation_2;
#else
     typedef VertexAdd<VertexAdd<VertexAdd<Vertex_<0>, VertexPolynomialProduct<VertexSub<Vertex_<1>, Vertex_<0> >, PolynomialXForVertexExpr<1> > >, VertexPolynomialProduct<VertexAdd<VertexSub<Vertex_<2>, Vertex_<0> >, VertexPolynomialProduct<VertexSub<VertexAdd<VertexSub<Vertex_<0>, Vertex_<1> >, Vertex_<3> >, Vertex_<2> >, PolynomialXForVertexExpr<1> > >, PolynomialYForVertexExpr<1> > >,VertexPolynomialProduct<VertexAdd<VertexAdd<VertexSub<Vertex_<4>, Vertex_<0> >, VertexPolynomialProduct<VertexAdd<VertexSub<VertexSub<Vertex_<0>, Vertex_<1> >, Vertex_<4> >, Vertex_<5> >, PolynomialXForVertexExpr<1> > >, VertexPolynomialProduct<VertexAdd<VertexAdd<VertexSub<VertexSub<Vertex_<0>, Vertex_<2> >, Vertex_<4> >, Vertex_<6> >, VertexPolynomialProduct<VertexSub<VertexAdd<VertexSub<VertexAdd<VertexAdd<VertexSub<VertexSub<Vertex_<1>, Vertex_<0> >, Vertex_<3> >, Vertex_<2> >, Vertex_<4> >, Vertex_<5> >, Vertex_<7> >, Vertex_<6> >, PolynomialXForVertexExpr<1> > >, PolynomialYForVertexExpr<1> > >, PolynomialZForVertexExpr<1> > > 
            Hexahedron_Transformation_2;
#endif /* _WIN32 */    
   //-----------------------------------------------------------------------------
#ifndef _WIN32
     Define_Element_Transformation
            (
              P_0() +
              ( P_1() - P_0()) * _U() +
              ( P_3() - P_0()) * _V() +
              ( P_4() - P_0()) * _W()
            )
              Cuboid_Transformation;
#else
     typedef VertexAdd<VertexAdd<VertexAdd<Vertex_<0>, VertexPolynomialProduct<VertexSub<Vertex_<1>, Vertex_<0> >, PolynomialXForVertexExpr<1> > >, VertexPolynomialProduct<VertexSub<Vertex_<3>, Vertex_<0> >, PolynomialYForVertexExpr<1> > >,VertexPolynomialProduct<VertexSub<Vertex_<4>, Vertex_<0> >, PolynomialZForVertexExpr<1> > > 
            Cuboid_Transformation;
#endif /* _WIN32 */    
   //-----------------------------------------------------------------------------
#ifndef _WIN32
     Define_Element_Transformation
            (
              P_0() +
              ( P_1() - P_0()) * _U() +
              ( P_2() - P_0()) * _V() +
              ( P_3() - P_0()) * _W()
            )
              Cuboid_Transformation_2;
#else
     typedef VertexAdd<VertexAdd<VertexAdd<Vertex_<0>, VertexPolynomialProduct<VertexSub<Vertex_<1>, Vertex_<0> >, PolynomialXForVertexExpr<1> > >, VertexPolynomialProduct<VertexSub<Vertex_<2>, Vertex_<0> >, PolynomialYForVertexExpr<1> > >,VertexPolynomialProduct<VertexSub<Vertex_<3>, Vertex_<0> >, PolynomialZForVertexExpr<1> > > 
            Cuboid_Transformation_2;
#endif /* _WIN32 */    
   //-----------------------------------------------------------------------------
#ifndef _WIN32
     Define_Element_Transformation
            (
              P_0() +
              ( P_1() - P_0()) * _U() +
              ( P_2() - P_0()) * _V() +
              ( P_3() - P_0()) * _W()
            )
              Tetrahedron_Transformation;
#else
     typedef VertexAdd<VertexAdd<VertexAdd<Vertex_<0>, VertexPolynomialProduct<VertexSub<Vertex_<1>, Vertex_<0> >, PolynomialXForVertexExpr<1> > >, VertexPolynomialProduct<VertexSub<Vertex_<2>, Vertex_<0> >, PolynomialYForVertexExpr<1> > >,VertexPolynomialProduct<VertexSub<Vertex_<3>, Vertex_<0> >, PolynomialZForVertexExpr<1> > > 
            Tetrahedron_Transformation;
#endif /* _WIN32 */    
   //-----------------------------------------------------------------------------
#ifndef _WIN32
     Define_Element_Transformation
            (
              P_0() +
              ( P_1() - P_0() ) * _U() +
              ( P_3() - P_0() +
               ( P_0() - P_1() + P_2() - P_3() ) * _U()) * _V() +
               ( P_4() - P_0() ) * _W()
            )
              Pyramid_Transformation;
#else
     typedef VertexAdd<VertexAdd<VertexAdd<Vertex_<0>, VertexPolynomialProduct<VertexSub<Vertex_<1>, Vertex_<0> >, PolynomialXForVertexExpr<1> > >, VertexPolynomialProduct<VertexAdd<VertexSub<Vertex_<3>, Vertex_<0> >, VertexPolynomialProduct<VertexSub<VertexAdd<VertexSub<Vertex_<0>, Vertex_<1> >, Vertex_<2> >, Vertex_<3> >, PolynomialXForVertexExpr<1> > >, PolynomialYForVertexExpr<1> > >,VertexPolynomialProduct<VertexSub<Vertex_<4>, Vertex_<0> >, PolynomialZForVertexExpr<1> > > 
            Pyramid_Transformation;
#endif /* _WIN32 */    
   //-----------------------------------------------------------------------------
#ifndef _WIN32
     Define_Element_Transformation
            (
              P_0() +
              ( P_1() - P_0() ) * _U() +
              ( P_2() - P_0() ) * _V() +
              ( P_3() - P_0() + (P_4() + P_0() - P_1() - P_3() )* _U() +
                                (P_5() + P_0() - P_2() - P_3() )* _V() ) * _W()
            )
              Prism_Transformation;
#else
     typedef VertexAdd<VertexAdd<VertexAdd<Vertex_<0>, VertexPolynomialProduct<VertexSub<Vertex_<1>, Vertex_<0> >, PolynomialXForVertexExpr<1> > >, VertexPolynomialProduct<VertexSub<Vertex_<2>, Vertex_<0> >, PolynomialYForVertexExpr<1> > >,VertexPolynomialProduct<VertexAdd<VertexAdd<VertexSub<Vertex_<3>, Vertex_<0> >, VertexPolynomialProduct<VertexSub<VertexSub<VertexAdd<Vertex_<4>, Vertex_<0> >, Vertex_<1> >, Vertex_<3> >, PolynomialXForVertexExpr<1> > >, VertexPolynomialProduct<VertexSub<VertexSub<VertexAdd<Vertex_<5>, Vertex_<0> >, Vertex_<2> >, Vertex_<3> >, PolynomialYForVertexExpr<1> > >, PolynomialZForVertexExpr<1> > > 
             Prism_Transformation;
#endif /* _WIN32 */    
   //-----------------------------------------------------------------------------
#ifndef _WIN32
     Define_Element_Transformation
            (
                P_0() +
              ( P_1() - P_0() ) * _U() +
              ( P_2() - P_0() ) * _V()
            )
              Triangle_Transformation;
#else
     typedef VertexAdd<VertexAdd<Vertex_<0>, VertexPolynomialProduct<VertexSub<Vertex_<1>, Vertex_<0> >, PolynomialXForVertexExpr<1> > >,VertexPolynomialProduct<VertexSub<Vertex_<2>, Vertex_<0> >, PolynomialYForVertexExpr<1> > > 
             Triangle_Transformation;
#endif /* _WIN32 */    
     //-----------------------------------------------------------------------------
#ifndef _WIN32
     Define_Element_Transformation
            (
              P_0() +
              ( P_1() - P_0() ) * _U() +
              ( P_3() - P_0() + ( P_0() - P_1() + P_2() - P_3() )* _U() ) * _V()
            )
              Quadrangle_Transformation;
#else
     typedef VertexAdd<VertexAdd<Vertex_<0>, VertexPolynomialProduct<VertexSub<Vertex_<1>, Vertex_<0> >, PolynomialXForVertexExpr<1> > >,VertexPolynomialProduct<VertexAdd<VertexSub<Vertex_<3>, Vertex_<0> >, VertexPolynomialProduct<VertexSub<VertexAdd<VertexSub<Vertex_<0>, Vertex_<1> >, Vertex_<2> >, Vertex_<3> >, PolynomialXForVertexExpr<1> > >, PolynomialYForVertexExpr<1> > > 
             Quadrangle_Transformation;
#endif /* _WIN32 */    
  //-----------------------------------------------------------------------------
#ifndef _WIN32
     Define_Element_Transformation
            (
              P_0() +
              ( P_1() - P_0() ) * _U() +
              ( P_2() - P_0() + ( P_0() - P_1() + P_3() - P_2() )* _U() ) * _V()
            )
              Quadrangle_Transformation_2;
#else
     typedef VertexAdd<VertexAdd<Vertex_<0>, VertexPolynomialProduct<VertexSub<Vertex_<1>, Vertex_<0> >, PolynomialXForVertexExpr<1> > >,VertexPolynomialProduct<VertexAdd<VertexSub<Vertex_<2>, Vertex_<0> >, VertexPolynomialProduct<VertexSub<VertexAdd<VertexSub<Vertex_<0>, Vertex_<1> >, Vertex_<3> >, Vertex_<2> >, PolynomialXForVertexExpr<1> > >, PolynomialYForVertexExpr<1> > > 
             Quadrangle_Transformation_2;
#endif /* _WIN32 */    
   //-----------------------------------------------------------------------------
#ifndef _WIN32
     Define_Element_Transformation
            (
              P_0() +
              ( P_1() - P_0() ) * _U()
            )
              Interval_Transformation;
#else
     typedef VertexAdd<Vertex_<0>,VertexPolynomialProduct<VertexSub<Vertex_<1>, Vertex_<0> >, PolynomialXForVertexExpr<1> > > 
             Interval_Transformation;
#endif /* _WIN32 */    
//--------------------------------------------------------------------------------
/*--------------------------------------------------------------------------------
   _Domain_ < \
   	number of vertices,
  	dimension D1 / D2 / D3 ,
   	mapping from reference to a general element,
  	interior / boundary,
  	number of basis functions of set 1,
  	number of basis functions of set 2,
        geometry of reference element,
   	Gaussian quadrature formula, Gauss1 / Gauss2 / Gauss3
   	double / complex<double>,
        STLVector / Array
           >
*/
//--------------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Hexahedron_
       : public _Domain_ <8,D3,Hexahedron_Transformation,interior,8,0,cuboid,accuracy,dTYPE,sTYPE>
        {
          _Hexahedron_()
             {
               this->Set ( ( 1. - X_(1) ) * ( 1. - Y_(1) ) * ( 1. - Z_(1) ) ) ;
               this->Set (        X_(1)   * ( 1. - Y_(1) ) * ( 1. - Z_(1) ) ) ;
               this->Set (        X_(1)   *        Y_(1)   * ( 1. - Z_(1) ) ) ;
               this->Set ( ( 1. - X_(1) ) *        Y_(1)   * ( 1. - Z_(1) ) ) ;
               this->Set ( ( 1. - X_(1) ) * ( 1. - Y_(1) ) *        Z_(1)   ) ;
               this->Set (        X_(1)   * ( 1. - Y_(1) ) *        Z_(1)   ) ;
               this->Set (        X_(1)   *        Y_(1)   *        Z_(1)   ) ;
               this->Set ( ( 1. - X_(1) ) *        Y_(1)   *        Z_(1)   ) ;
             }
        } ;
   // Simple type for the standard element
     typedef _Hexahedron_<> Hexahedron;
//--------------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Hexahedron_2
       : public _Domain_ <8,D3,Hexahedron_Transformation_2,interior,8,0,cuboid,accuracy,dTYPE,sTYPE>
        {
          _Hexahedron_2()
             {
               this->Set ( ( 1. - X_(1) ) * ( 1. - Y_(1) ) * ( 1. - Z_(1) ) ) ;
               this->Set (        X_(1)   * ( 1. - Y_(1) ) * ( 1. - Z_(1) ) ) ;
               this->Set ( ( 1. - X_(1) ) *        Y_(1)   * ( 1. - Z_(1) ) ) ;
               this->Set (        X_(1)   *        Y_(1)   * ( 1. - Z_(1) ) ) ;
               this->Set ( ( 1. - X_(1) ) * ( 1. - Y_(1) ) *        Z_(1)   ) ;
               this->Set (        X_(1)   * ( 1. - Y_(1) ) *        Z_(1)   ) ;
               this->Set ( ( 1. - X_(1) ) *        Y_(1)   *        Z_(1)   ) ;
               this->Set (        X_(1)   *        Y_(1)   *        Z_(1)   ) ;
             }
        } ;
   // Simple type for the standard element
     typedef _Hexahedron_2<> Hexahedron_2;
   //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Hexahedron_Boundary_
       : public _Domain_ <8,D3,Hexahedron_Transformation,boundary_with_derivatives,4,0,quadrangle,accuracy,dTYPE,sTYPE>
        {
          _Hexahedron_Boundary_()
             {
               this->Set ( ( 1. - X_(1) ) * ( 1. - Y_(1) ) ) ;
               this->Set (        X_(1)   * ( 1. - Y_(1) ) ) ;
               this->Set (        X_(1)   *        Y_(1)   ) ;
               this->Set ( ( 1. - X_(1) ) *        Y_(1)   ) ;
             }
        } ;
   // Simple type for the standard element
     typedef _Hexahedron_Boundary_<> Hexahedron_Boundary;
   //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Cuboid_
       : public _Domain_<8,D3,Cuboid_Transformation,interior,8,0,cuboid,accuracy,dTYPE,sTYPE>
        {
          _Cuboid_()
             {
               this->Set ( ( 1 - X_() ) * ( 1 - Y_() ) * ( 1 - Z_() ) ) ;
               this->Set (       X_()   * ( 1 - Y_() ) * ( 1 - Z_() ) ) ;
               this->Set (       X_()   *       Y_()   * ( 1 - Z_() ) ) ;
               this->Set ( ( 1 - X_() ) *       Y_()   * ( 1 - Z_() ) ) ;
               this->Set ( ( 1 - X_() ) * ( 1 - Y_() ) *       Z_()   ) ;
               this->Set (       X_()   * ( 1 - Y_() ) *       Z_()   ) ;
               this->Set (       X_()   *       Y_()   *       Z_()   ) ;
               this->Set ( ( 1 - X_() ) *       Y_()   *       Z_()   ) ;
             }
        } ;
   // Simple type for the standard element
     typedef _Cuboid_<> Cuboid;
   //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct Vector_Cuboid_
       : public _Domain_<8,D3,Cuboid_Transformation,interior,12,0,cuboid,accuracy,dTYPE,sTYPE,float,
           BasisFunctionAndValueClass<dTYPE,D3,Gauss<float,accuracy,cuboid>::numberGaussianPoints+1,vectorBasisFunctions,12> >
        {
          Vector_Cuboid_()
             {
               this->Set ( fVec(  (1 - Y_()) * (1 - Z_()), Null_(), Null_()), 0,1 ) ;
               this->Set ( fVec(  Y_() * (1 - Z_())      , Null_(), Null_()), 3,2 ) ;
               this->Set ( fVec(  (1 - Y_()) * Z_()      , Null_(), Null_()), 4,5 ) ;
               this->Set ( fVec(   Y_() * Z_()           , Null_(), Null_()), 7,6 ) ;

               this->Set ( fVec(  Null_(), (1 - X_()) * (1 - Z_()), Null_()), 0,4 ) ;
               this->Set ( fVec(  Null_(),  X_() * (1 - Z_())     , Null_()), 1,2 ) ;
               this->Set ( fVec(  Null_(),  (1 - X_()) * Z_()     , Null_()), 4,7 ) ;
               this->Set ( fVec(  Null_(),   X_() * Z_()          , Null_()), 5,6 ) ;

               this->Set ( fVec(  Null_(), Null_(), (1 - X_()) * (1 - Y_())), 0,4 ) ;
               this->Set ( fVec(  Null_(), Null_(),  X_() * (1 - Y_()))     , 1,5 ) ;
               this->Set ( fVec(  Null_(), Null_(), (1 - X_()) * Y_())      , 3,7 ) ;
               this->Set ( fVec(  Null_(), Null_(),  X_() * Y_())           , 2,6 ) ;
             }
        } ;
   //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2 >
     struct _Cuboid_Boundary_
       : public _Domain_ <8,D3,Cuboid_Transformation,boundary_with_derivatives,4,0,quadrangle,accuracy,double,STLVector> 
        {
          _Cuboid_Boundary_()
             {
               this->Set ( ( 1. - X_(1) ) * ( 1. - Y_(1) ) ) ;
               this->Set (        X_(1)   * ( 1. - Y_(1) ) ) ;
               this->Set (        X_(1)   *        Y_(1)   ) ;
               this->Set ( ( 1. - X_(1) ) *        Y_(1)   ) ;
             }
        } ;
     //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Cuboid_Mixed_
       : public _Domain_<8,D3,Cuboid_Transformation,interior,2,9,cuboid,accuracy,dTYPE,sTYPE>
         {
           _Cuboid_Mixed_()
              {
                this->Set ( BasisSet_1,X_(1)) ;
                this->Set ( BasisSet_1,Y_(1)) ;
#if 0
                this->Set ( ( 1. - X_(1) ) * ( 1. - Y_(1) ) * ( 1. - Z_(1) ) ) ;
                this->Set (        X_(1)   * ( 1. - Y_(1) ) * ( 1. - Z_(1) ) ) ;
                this->Set (        X_(1)   *        Y_(1)   * ( 1. - Z_(1) ) ) ;
                this->Set ( ( 1. - X_(1) ) *        Y_(1)   * ( 1. - Z_(1) ) ) ;
                this->Set ( ( 1. - X_(1) ) * ( 1. - Y_(1) ) *        Z_(1)   ) ;
                this->Set (        X_(1)   * ( 1. - Y_(1) ) *        Z_(1)   ) ;
                this->Set (        X_(1)   *        Y_(1)   *        Z_(1)   ) ;
                this->Set ( ( 1. - X_(1) ) *        Y_(1)   *        Z_(1)   ) ;
#endif     
                this->Set ( BasisSet_2,( 1. - X_(1) ) * ( 1. - Y_(1) ) * ( 1. - Z_(1) ) + 1. ) ;
                this->Set ( BasisSet_2,       X_(1)   * ( 1. - Y_(1) ) * ( 1. - Z_(1) ) + 1. ) ;
                this->Set ( BasisSet_2,       X_(1)   *        Y_(1)   * ( 1. - Z_(1) ) + 1. ) ;
                this->Set ( BasisSet_2,( 1. - X_(1) ) *        Y_(1)   * ( 1. - Z_(1) ) + 1. ) ;
                this->Set ( BasisSet_2,( 1. - X_(1) ) * ( 1. - Y_(1) ) *        Z_(1)   + 1. ) ;
                this->Set ( BasisSet_2,       X_(1)   * ( 1. - Y_(1) ) *        Z_(1)   + 1. ) ;
                this->Set ( BasisSet_2,1. + Y_(1) + Z_(1) + 1. ) ;
                this->Set ( BasisSet_2,1. + Y_(1) + Z_(1) + 1. ) ;
                this->Set ( BasisSet_2,1. + Y_(1) + Z_(1) + 1. ) ;
              }
        };
   //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Tetrahedron_
       : public _Domain_<4,D3,Tetrahedron_Transformation,interior,4,0,tetrahedron,accuracy,dTYPE,sTYPE>
        {
          _Tetrahedron_()
            {
              this->Set ( 1. - X_(1) - Y_(1) - Z_(1) ) ;
              this->Set ( X_(1)  ) ;
              this->Set ( Y_(1)  ) ;
              this->Set ( Z_(1)  ) ;
            }
        } ;
   // Simple type for the standard element
      typedef _Tetrahedron_ <> Tetrahedron;
   //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct Vector_Tetrahedron_
       : public _Domain_<4,D3,Tetrahedron_Transformation,interior,6,0,tetrahedron,accuracy,dTYPE,sTYPE,float,
           BasisFunctionAndValueClass<dTYPE,D3,Gauss<float,accuracy,tetrahedron>::numberGaussianPoints+1,vectorBasisFunctions,6> >
        {
          Vector_Tetrahedron_()
             {
               this->Set ( fVec( ( 1 - Y_()  - Z_() ) , X_()  , X_() ), 0,1);
               this->Set ( fVec(  Y_()  , 1 - X_() - Z_(), Y_() ), 0, 2); 
               this->Set ( fVec(  Z_(), Z_() , 1 - X_() - Y_() ), 0, 3);
               this->Set ( fVec( Y_(),  - X_()  , Null_() ), 1, 2);
               this->Set ( fVec( Z_(), Null_(), - X_() ), 1, 3); 
               this->Set ( fVec( Null_(), Z_(), - Y_() ), 2, 3);
             }
        } ;
   //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Tetrahedron_Boundary_
       : public _Domain_ <4,D3,Tetrahedron_Transformation,boundary_with_derivatives,3,0,triangle,accuracy,dTYPE,sTYPE>
        {
          _Tetrahedron_Boundary_()
            {
              this->Set ( 1. - X_(1) - Y_(1) ) ;
              this->Set ( X_(1) ) ;
              this->Set ( Y_(1) ) ;
            }
        } ;
   // Simple type for the standard element
      typedef _Tetrahedron_Boundary_ <> Tetrahedron_Boundary;
    //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Pyramid_
       : public _Domain_<5,D3,Pyramid_Transformation,interior,5,0,pyramid,accuracy,dTYPE,sTYPE>
        {
          _Pyramid_()
             {
               this->Set ( ( 1. - X_(1) ) * ( 1. - Y_(1) ) * ( 1. -  Z_(1) ) ) ;
               this->Set (        X_(1)   * ( 1. - Y_(1) ) * ( 1. -  Z_(1) ) ) ;
               this->Set (        X_(1)   *        Y_(1)   * ( 1. -  Z_(1) ) ) ;
               this->Set ( ( 1. - X_(1) ) *        Y_(1)   * ( 1. -  Z_(1) ) ) ;
               this->Set (                                       Z_(1)   ) ;
             }
        } ;
   // Simple type for the standard element
      typedef _Pyramid_ <> Pyramid;
    //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Prism_
       : public _Domain_<6,D3,Prism_Transformation,interior,6,0,prism,accuracy,dTYPE,sTYPE>
        {
          _Prism_()
             {
               this->Set ( ( 1. - X_(1)  - Y_(1) ) * ( 1. -  Z_(1) ) ) ;
               this->Set (        X_(1)   *  ( 1. -  Z_(1) ) ) ;
               this->Set (        Y_(1)   *  ( 1. -  Z_(1) ) ) ;
               this->Set ( ( 1. - X_(1)  - Y_(1) ) *  Z_(1)  ) ;
               this->Set (        X_(1)   *  Z_(1) ) ;
               this->Set (        Y_(1)   *  Z_(1) ) ;
             }
        } ;
   // Simple type for the standard element
      typedef _Prism_ <> Prism;
     //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Triangle_
       : public _Domain_<3,D2,Triangle_Transformation,interior,3,0,triangle,accuracy,dTYPE,sTYPE>
        {
          _Triangle_()
             {
               this->Set ( 1. - X_(1) - Y_(1) ) ;
               this->Set ( X_(1) ) ;
               this->Set ( Y_(1) ) ;
             }
        } ;
   // Simple type for the standard element
      typedef _Triangle_<> Triangle;
     //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Triangle_Quadratic_
       : public _Domain_<3,D2,Triangle_Transformation,interior,6,0,triangle,accuracy,dTYPE,sTYPE>
        {
          _Triangle_Quadratic_()
             {
               this->Set ( 2 * (1 - X_(1) - Y_(1) )  * ( 0.5 - X_(1) - Y_(1) ) ) ;
               this->Set ( 2 * ( X_(1)  * (  X_(1) - 0.5 ) ) ) ;
               this->Set ( 2 * ( Y_(1)  * (  Y_(1) - 0.5 ) ) ) ;
               this->Set ( 4 * (1 - X_(1) - Y_(1) ) * X_(1) ) ;
               this->Set ( 4 * ( X_(1) * Y_(1) ) ) ;
               this->Set ( 4 * (1 - X_(1) - Y_(1) ) * Y_(1) ) ;
             }
        } ;
   //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct Vector_Triangle_
       : public _Domain_<3,D2,Triangle_Transformation,interior,3,0,triangle,accuracy,dTYPE,sTYPE,float,
             BasisFunctionAndValueClass<dTYPE,D2,Gauss<float,accuracy,triangle>::numberGaussianPoints+1,vectorBasisFunctions,3> >
        {
          Vector_Triangle_()
             {
               this->Set ( fVec( 1 - Y_() ,  X_()     ), 0, 1);
               this->Set ( fVec(   - Y_() ,  X_()     ), 1, 2);
               this->Set ( fVec(   - Y_() ,  X_() - 1 ), 2, 0);
             }
        } ;


   //-----------------------------------------------------------------------------
     /*
      * Quadrangle with the following transformation
      *   P3---------P2
      *   |           |
      *   |           |
      *   |           |
      *   P0---------P1
      */
     template<IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double,
    		 stencilType sTYPE = STLVector>
     struct _Quadrangle_: public _Domain_<4, D2, Quadrangle_Transformation, interior,
     4, 0, quadrangle, accuracy, dTYPE, sTYPE> {
    	 _Quadrangle_() {
    		 this->Set((1 - X_(1)) * (1 - Y_(1)));
    		 this->Set(X_(1) * (1 - Y_(1)));
    		 this->Set(X_(1) * Y_(1));
    		 this->Set((1 - X_(1)) * Y_(1));
    	 }
     };

     // Simple type for the standard element
     typedef _Quadrangle_<> Quadrangle;


   //-----------------------------------------------------------------------------
     /*
      * Quadrangle with the following transformation
      *   P2---------P3
      *   |           |
      *   |           |
      *   |           |
      *   P0---------P1
      */
   //-----------------------------------------------------------------------------
     template<IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double,
    		 stencilType sTYPE = STLVector>
     struct _Quadrangle_2: public _Domain_<4, D2, Quadrangle_Transformation_2,
     interior, 4, 0, quadrangle, accuracy, dTYPE, sTYPE> {
    	 _Quadrangle_2() {
    		 this->Set((1 - X_(1)) * (1 - Y_(1)));
    		 this->Set(X_(1) * (1 - Y_(1)));
    		 this->Set(X_(1) * Y_(1));
    		 this->Set((1 - X_(1)) * Y_(1));
    	 }
     };

     // Simple type for the standard element
     typedef _Quadrangle_2<> Quadrangle_2;


   //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct Vector_Quadrangle_
       : public _Domain_<4,D2,Quadrangle_Transformation,interior,4,0,quadrangle,accuracy,dTYPE,sTYPE,float,
            BasisFunctionAndValueClass<dTYPE,D2,Gauss<float,accuracy,quadrangle>::numberGaussianPoints+1,vectorBasisFunctions,4> >
        {
          Vector_Quadrangle_()
             {
               this->Set ( fVec( ( 1 - Y_() ), Null_() ), 0, 1);
               this->Set ( fVec(       Y_()  , Null_() ), 3, 2); 
               this->Set ( fVec(    Null_()  , 1 -X_() ), 0, 3);
               this->Set ( fVec(    Null_()  ,    X_() ), 1, 2);
             }
        } ;
   //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Triangle3D_
       : public _Domain_<3,D3,Triangle_Transformation,boundary,3,0,triangle,accuracy,dTYPE,sTYPE>
        {
          _Triangle3D_ ()
             {
               this->Set ( 1. - X_(1) - Y_(1) ) ;
               this->Set ( X_(1)  ) ;
               this->Set ( Y_(1)  ) ;
             }
        } ;
     //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Quadrangle3D_
       : public _Domain_<4,D3,Quadrangle_Transformation,boundary,4,0,quadrangle,accuracy,dTYPE,sTYPE>
        {
          _Quadrangle3D_()
             {
               this->Set ( ( 1. - X_(1) ) * ( 1. - Y_(1) ) ) ;
               this->Set ( X_(1)* ( 1. - Y_(1) ) ) ;
               this->Set ( X_(1)* Y_(1) ) ;
               this->Set ( ( 1. - X_(1) ) * Y_(1)) ;
             }
        } ;
     //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Quadrangle3D_2
       : public _Domain_<4,D3,Quadrangle_Transformation_2,boundary,4,0,quadrangle,accuracy,dTYPE,sTYPE>
        {
          _Quadrangle3D_2()
             {
               this->Set ( ( 1. - X_(1) ) * ( 1. - Y_(1) ) ) ;
               this->Set ( X_(1)* ( 1. - Y_(1) ) ) ;
               this->Set ( X_(1)* Y_(1) ) ;
               this->Set ( ( 1. - X_(1) ) * Y_(1)) ;
             }
        } ;
     //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Interval_
       : public _Domain_<2,D1,Interval_Transformation,interior,2,0,interval,accuracy,dTYPE,sTYPE>
        {
          _Interval_()
             {
               this->Set ( 1. - X_(1) ) ;
               this->Set ( X_(1) ) ;
             }
        } ;
     //-----------------------------------------------------------------------------
     template < IntegrationAccuracy accuracy = Gauss2, typename dTYPE = double, stencilType sTYPE = STLVector>
     struct _Edge2D_
       : public _Domain_<2,D2,Triangle_Transformation,boundary,2,0,interval,accuracy,dTYPE,sTYPE>
        {
          _Edge2D_()
             {
               this->Set ( 1. - X_(1) ) ;
               this->Set ( X_(1) ) ;
             }
        } ;
     //-----------------------------------------------------------------------------
   }
//==============================================================================
