// ------------------------------------------------------------
// main.cc
//
// ------------------------------------------------------------

#include "source/linAlg.h"



int main(int argc, char** argv)
{
  cout.precision(10);
  cout.setf(std::ios::fixed,std::ios::floatfield);

  std::ifstream PARAMETER;
  int iteration, i, n, m, m_max, iter_relax;
  int level;

  double normi;  

  ofstream DATEI;

  PARAMETER.open("para.dat",std::ios::in);
  PARAMETER >> n >> iteration >> iter_relax;
  PARAMETER.close();

  cout << "\n Linear Algebra \n";

  SimpleIndex index(4);
  SimpleIndex indexI(5);

  VectorAlg<double> va(5);
  VectorAlg<double> ua(5);
  VectorAlg<double> wa(5);

  VectorIndex<double> v(indexI);
  VectorIndex<double> u(indexI);
  VectorIndex<double> w(indexI);


  v = 1.0;
  w = 1.0;
  u = v + w;
  
  u.Print();

  
  /*
  va = 1.0;
  wa = 3.0;  
  ua = va + wa;
  
  
  ua.Print();
  */
  
  
  MatrixAlg<double> Mva(5,4);
  MatrixAlg<double> Mua(5,4);
  MatrixAlg<double> Mwa(5,4);

  MatrixIndex<double> Mv(indexI, indexI);
  MatrixIndex<double> Mu(indexI, indexI);
  MatrixIndex<double> Mw(indexI, indexI); 
  
  /*
  Mv = 2.0;
  Mw = 3.0;
  Mu = Mv + Mw;

  v = Mu(u);
  
  Mu.Print();
  
  v.Print();
  */
  
  cout << " Matrix Test! " << endl;

  Mw.setValueSS(0,0,8.0);   Mw.setValueSS(0,1,2.0);   Mw.setValueSS(0,2,1.0);
  Mw.setValueSS(1,0,5.0);   Mw.setValueSS(1,1,10.0);  Mw.setValueSS(1,2,1.2);
  Mw.setValueSS(2,0,-1.0);  Mw.setValueSS(2,1,3.5);   Mw.setValueSS(2,2,22.0);

  Mw.setValueSS(4,0,-44.0);  Mw.setValueSS(3,1,3.77);   Mw.setValueSS(2,4,-11.0); 
  Mw.setValueSS(4,3,-3.4);
 
  
/*
  Mw.setValueSS(0,0, 4.0);   Mw.setValueSS(0,1,-2.0);
  Mw.setValueSS(1,0, 1.0);   Mw.setValueSS(1,1,2.0);
  */

  v = 3.1;
  v.setValueS(1,2.4);
  v.setValueS(2,1.4);
  v.setValueS(3,4.4);

  v.Print();
  
  u = Mw(v);

//  cout << " Mw: " << endl;
//  Mw.Print();

  
  Mv = (InvertMatrix<double>(Mw));

//  cout << " Mw: " << endl;
//  Mw.Print();
  
  cout << " Mv: " << endl;
  Mv.Print();
  
  
  w = Mv(u);
  
  MatrixIndex<double>* pMv = &Mv;
  VectorIndex<double>* pu  = &u;
  VectorIndex<double>* pw  = &w;
  
  (*pw) = (*pMv)(*pu);
    
  
  w.Print();
  
  cout << " Ende! " << endl;

}


