/**********************************************************************************
 * Copyright 2010 Christoph Pflaum 
 * 		Department Informatik Lehrstuhl 10 - Systemsimulation
 *		Friedrich-Alexander Universität Erlangen-Nürnberg
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **********************************************************************************/
 
#ifndef PARALLEL_H
#define PARALLEL_H


////////////////////////////////////////////////////////////////////

// Code for getting MPI data typ
template <class DTyp>
struct Give_MPI_data_typ {
  static int Give();
};

// Code for getting MPI data typ
template <class DTyp>
struct Make_MPI_All_Sum {
  static DTyp Do(DTyp x, MPI_Comm comm);
};

template <class DTyp>
class Parallel_buffer {
 public:
  // data
  static DTyp* receive;
  static DTyp* send;
  static int size_receive;
  static int size_send;

  // Put data
  static DTyp* Give_send(int size);
  static DTyp* Give_receive(int size);
};


template <class DTyp>
DTyp* Parallel_buffer<DTyp>::Give_send(int size) { 
  if(size>size_send) {
    if(size_send!=0) delete [] send;
    send = new DTyp[size];
    size_send = size;
  }
  return send;
}



template <class DTyp>
DTyp* Parallel_buffer<DTyp>::Give_receive(int size) { 
  if(size>size_receive) {
    if(size_receive!=0) delete [] receive;
    receive = new DTyp[size];
    size_receive = size;
  }
  return receive;
}



#endif // PARALLEL_H
