#ifndef EXAMPLES_UG_OPTICS_H
#define EXAMPLES_UG_OPTICS_H
#include <vector>


class GeometryWithBoundaryPoints {
public:      
    std::vector<D3vector> getBoundaryPoints(){return boundaryPoints;}
protected:
     std::vector<D3vector> boundaryPoints;     
};


/** \addtogroup GridGeneration **/
/* @{ */   
class Lens_Geometry :  public Unstructured_grid {
 public:
  Lens_Geometry(double Radius, double thickness, double curvatureLeft, double curvatureRight, double offsetX, double offsetY, double offsetZ, bool inner_grid_arched = false, double radius = 0.0);
  ~Lens_Geometry(){};

  double Radius;
  double radius;
  double length;

  private:

};

class Lens_Geometry_Quad : public GeometryWithBoundaryPoints, public Unstructured_grid {
    public:
    Lens_Geometry_Quad(double Radius, double thickness, double curvatureLeft, double curvatureRight, double offsetX, double offsetY, double offsetZ, bool inner_grid_arched = false, double radius = 0.0, double cut_edge_from_left = 0, double cut_edge_from_right = 0);
    ~Lens_Geometry_Quad(){};


    double getThickness(){return thickness_;};
    double getOffsetX(){return offsetX_;};
    double getOffsetY(){return offsetY_;};
    double getOffsetZ(){return offsetZ_;};
    double getFocalLength(){return focalLength_;};
    private:      
    double Radius_;
    double radius_;
    double thickness_;
    double offsetX_;
    double offsetY_;
    double offsetZ_;
    double focalLength_;
};

class Lens_Geometry_cutted_edges : public GeometryWithBoundaryPoints, public Unstructured_grid {
    public:
     Lens_Geometry_cutted_edges(double RadiusLeft, double RadiusRight, double MechanicalRadiusLeft,double MechanicalRadiusRight, double thickness, double curvatureLeft, double curvatureRight, double offsetX, double offsetY, double offsetZ, bool inner_grid_arched = false, double radius = 0.0);
    ~Lens_Geometry_cutted_edges(){};

    double getThickness(){return thickness_;};
    double getOffsetX(){return offsetX_;};
    double getOffsetY(){return offsetY_;};
    double getOffsetZ(){return offsetZ_;};
    double getFocalLength(){return focalLength_;};
    private:

    double Radius_;
    double radius_;
    double thickness_;
    double offsetX_;
    double offsetY_;
    double offsetZ_;
    double focalLength_;
};


/* @} */


#endif // EXAMPLES_UG_OPTICS_H
