/**********************************************************************************
 * Copyright 2010 Christoph Pflaum 
 * 		Department Informatik Lehrstuhl 10 - Systemsimulation
 *		Friedrich-Alexander Universität Erlangen-Nürnberg
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **********************************************************************************/

#ifndef UGBLOCK_H_
#define UGBLOCK_H_

#ifdef _OPENMP
#include <omp.h>
#endif


#include "mympi.h"

#include "abbrevi.h"
#include "parameter.h"
#include "math_lib/math_lib.h"
#include "math_lib/mg_array.h"
#include "basics/basic.h"
#include "grid/elements.h"
#include "grid/parti.h"
#include "grid/ug.h"
#include "grid/examples_ug.h"
#include "grid/examples_ug_optics.h"
#include "grid/blockgrid.h"
#include "grid/compose_grid.h"

#include "vtk/vtkReader.h"

#include "grid/marker.h"
#include "extemp/parallel.h"
#include "extemp/extemp.h"
#include "extemp/co_fu.h"
#include "extemp/functor.h"
#include "extemp/variable.h"
#include "extemp/variable_cc.h"
#include "extemp/print_var_vtk_cc.h"
#include "extemp/cellvar.h"
#include "extemp/phaseshift_cc.h"
#include "extemp/vari_zordering.h"

#include "extemp/copy.h"
//#include "../../../Colsamm/Source/Colsamm.h"
//#include "/homes/staff/pflaum/CCOL/myColsamm/Source/Colsamm.h"
#include "../../Source_Colsamm/Colsamm.h"
#include "pde_op/diffop.h"
#include "pde_op/stenop.h"
#include "pde_op/stenop_cc.h"
#include "pde_op/diffbo.h"
#include "pde_op/diffop_cc.h"
#include "pde_op/shiftop.h"
#include "pde_op/petrov.h"
#include "pde_op/ressten.h"
#include "pde_op/mgop.h"
#include "interpol/interpol.h"
#include "interpol/interpolCellVar.h"
#include "ugopenmp.h"


#endif // UGBLOCK_H_
