######################################################################
# ugblocks 3D 
######################################################################



DEPENDPATH += ./ \
              $${UGBLOCKS_PATH}/program/source \
              $${UGBLOCKS_PATH}/program/source/basics \
              $${UGBLOCKS_PATH}/program/source/extemp \
              $${UGBLOCKS_PATH}/program/source/grid \
              $${UGBLOCKS_PATH}/program/source/interpol \
              $${UGBLOCKS_PATH}/program/source/math_lib \
              $${UGBLOCKS_PATH}/program/source/pde_op \
	      $${UGBLOCKS_PATH}/program/source/vtk 
INCLUDEPATH += . \
               $${UGBLOCKS_PATH}/program/source \
               $${UGBLOCKS_PATH}/program/source/math_lib \
               $${UGBLOCKS_PATH}/program/source/basics \
               $${UGBLOCKS_PATH}/program/source/grid \
               $${UGBLOCKS_PATH}/program/source/extemp \
               $${UGBLOCKS_PATH}/program/source/pde_op \
	          $${UGBLOCKS_PATH}/program/source/vtk \
               $${UGBLOCKS_PATH}/program/source/interpol \
			$${UGBLOCKS_PATH}/program/source/directSolver 
				

# Input
HEADERS += $${UGBLOCKS_PATH}/program/source/abbrevi.h \
           $${UGBLOCKS_PATH}/program/source/mympi.h \
           $${UGBLOCKS_PATH}/program/source/parameter.h \
           $${UGBLOCKS_PATH}/program/source/ugblock.h \
           $${UGBLOCKS_PATH}/program/source/ugopenmp.h \
           $${UGBLOCKS_PATH}/program/source/basics/basic.h \
           $${UGBLOCKS_PATH}/program/source/extemp/cellvar.h \
           $${UGBLOCKS_PATH}/program/source/extemp/co_fu.h \
           $${UGBLOCKS_PATH}/program/source/extemp/copy.h \
           $${UGBLOCKS_PATH}/program/source/extemp/extemp.h \
           $${UGBLOCKS_PATH}/program/source/extemp/functor.h \
           $${UGBLOCKS_PATH}/program/source/extemp/parallel.h \
           $${UGBLOCKS_PATH}/program/source/extemp/phaseshift_cc.h \
           $${UGBLOCKS_PATH}/program/source/extemp/vari_zordering.h \
           $${UGBLOCKS_PATH}/program/source/extemp/variable.h \
           $${UGBLOCKS_PATH}/program/source/extemp/variable_cc.h \
           $${UGBLOCKS_PATH}/program/source/extemp/print_var_vtk_cc.h \
           $${UGBLOCKS_PATH}/program/source/grid/blockgrid.h \
           $${UGBLOCKS_PATH}/program/source/grid/elements.h \
           $${UGBLOCKS_PATH}/program/source/grid/examples_ug.h \
           $${UGBLOCKS_PATH}/program/source/grid/examples_ug_optics.h \
           $${UGBLOCKS_PATH}/program/source/grid/compose_grid.h \
           $${UGBLOCKS_PATH}/program/source/grid/marker.h \
           $${UGBLOCKS_PATH}/program/source/grid/parti.h \
           $${UGBLOCKS_PATH}/program/source/grid/ug.h \
           $${UGBLOCKS_PATH}/program/source/interpol/interpol.h \
           $${UGBLOCKS_PATH}/program/source/interpol/interpolCellVar.h \           
           $${UGBLOCKS_PATH}/program/source/math_lib/math_lib.h \
           $${UGBLOCKS_PATH}/program/source/math_lib/mg_array.h \
           $${UGBLOCKS_PATH}/program/source/pde_op/diffbo.h \
           $${UGBLOCKS_PATH}/program/source/pde_op/mgop.h \
           $${UGBLOCKS_PATH}/program/source/pde_op/shiftop.h \
           $${UGBLOCKS_PATH}/program/source/pde_op/diffop.h \
           $${UGBLOCKS_PATH}/program/source/pde_op/diffop_cc.h \
           $${UGBLOCKS_PATH}/program/source/pde_op/ressten.h \
           $${UGBLOCKS_PATH}/program/source/pde_op/stenop.h \
           $${UGBLOCKS_PATH}/program/source/pde_op/stenop_cc.h \
           $${UGBLOCKS_PATH}/program/source/vtk/vtkReader.h \
           $${UGBLOCKS_PATH}/common_source/mathlib/math_lib_common.h \
           $${UGBLOCKS_PATH}/common_source/abbrevi_common.h \
           $${UGBLOCKS_PATH}/common_source/extemp_type.h
             
  
SOURCES += $${UGBLOCKS_PATH}/program/source/ugopenmp.cc \
           $${UGBLOCKS_PATH}/program/source/extemp/cellvar.cc \
           $${UGBLOCKS_PATH}/program/source/extemp/parallel.cc \
           $${UGBLOCKS_PATH}/program/source/extemp/print_var_avs.cc \
           $${UGBLOCKS_PATH}/program/source/extemp/print_var_dx.cc \
           $${UGBLOCKS_PATH}/program/source/extemp/print_var_vtk.cc \
           $${UGBLOCKS_PATH}/program/source/extemp/variable.cc \
           $${UGBLOCKS_PATH}/program/source/extemp/extemp.cc \           
           $${UGBLOCKS_PATH}/program/source/grid/blockgrid.cc \
           $${UGBLOCKS_PATH}/program/source/grid/elements.cc \
           $${UGBLOCKS_PATH}/program/source/grid/examples_ug.cc \
           $${UGBLOCKS_PATH}/program/source/grid/examples_ug_optics.cc \
           $${UGBLOCKS_PATH}/program/source/grid/compose_grid.cc \
           $${UGBLOCKS_PATH}/program/source/grid/pyramid_ug.cc \
           $${UGBLOCKS_PATH}/program/source/grid/slabOblique_ug.cc \
           $${UGBLOCKS_PATH}/program/source/grid/marker.cc \
           $${UGBLOCKS_PATH}/program/source/grid/parti.cc \
           $${UGBLOCKS_PATH}/program/source/grid/print_avs.cc \
           $${UGBLOCKS_PATH}/program/source/grid/print_dx.cc \
           $${UGBLOCKS_PATH}/program/source/extemp/output_vtk.cc \           
           $${UGBLOCKS_PATH}/program/source/extemp/print_var_Qt_vtk.cc \
           $${UGBLOCKS_PATH}/program/source/grid/ug.cc \
           $${UGBLOCKS_PATH}/program/source/pde_op/shiftop.cc \
           $${UGBLOCKS_PATH}/program/source/grid/zordering.cc \
           $${UGBLOCKS_PATH}/program/source/interpol/interpol.cc \
           $${UGBLOCKS_PATH}/program/source/interpol/interpolCellVar.cc \           
           $${UGBLOCKS_PATH}/program/source/math_lib/math_lib.cc \
           $${UGBLOCKS_PATH}/program/source/pde_op/mgop.cc \
           $${UGBLOCKS_PATH}/program/source/vtk/vtkReader.cc
