#include "interpolation2D.h"

Interpolation2D::Interpolation2D(Blockgrid2D& grid_from_, Blockgrid2D& grid_to_)
    : grid_from(grid_from_), grid_to(grid_to_), isSlice(false)
{
  assert(grid_from.Give_unstructured_grid() == grid_to.Give_unstructured_grid() && "unstructured grids must be equivalent!");
  Unstructured2DGrid& ug = *(grid_from.Give_unstructured_grid());
  // for parallel
  my_rank = ug.Give_my_rank();
  comm = ug.Give_MPI_comm();
}


Interpolation2D::Interpolation2D(Blockgrid2DFrom3D& grid_from_, Blockgrid2DFrom3D& grid_to_)
: grid_from(grid_from_), grid_to(grid_to_), isSlice(true)
{
  assert(((UGFrom3DSlice*)grid_from.Give_unstructured_grid())->Give_unstructured_grid() == ((UGFrom3DSlice*)grid_to.Give_unstructured_grid())->Give_unstructured_grid() && "unstructured 3D grids must be equivalent!");
  Unstructured2DGrid& ug = *(grid_from.Give_unstructured_grid());
  // for parallel
  my_rank = ug.Give_my_rank();
  comm = ug.Give_MPI_comm();
}
