/**********************************************************************************
 * Copyright 2010 Christoph Pflaum 
 * 		Department Informatik Lehrstuhl 10 - Systemsimulation
 *		Friedrich-Alexander Universität Erlangen-Nürnberg
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **********************************************************************************/


// ------------------------------------------------------------
// parti.h
//
// ------------------------------------------------------------

#ifndef PARTI2D_H_
#define PARTI2D_H_

#include "../mympi2D.h"

//  Partitioning2D
// ---------------------------------

class Partitioning2D {
 public:
  Partitioning2D();
  ~Partitioning2D() {};

  int Give_my_rank() { return my_rank; }
  MPI_Comm Give_MPI_comm() { return comm; }
  bool partitioning_is_done() { return partitioning_done; }
  int number_of_processors() { return p; }
  int number_of_used_processors() { return max_rank_used; }

 protected:
  MPI_Comm comm;
  int p;                 // number of processes
  int max_rank_used;     // maximal rank of processes used
  int my_rank;

  bool partitioning_done;
};



#endif
     
