#ifdef _OPENMP
#include <omp.h>
#endif

#include "../../../program/source/mympi.h"  // von 3D UGBlocks
#include "../../../Source_Colsamm/Colsamm.h"
using namespace ::_COLSAMM_;


#include "../abbrevi2D.h"
#include "../math_lib/math_lib.h"
#include "../math_lib/mg_array.h"
#include "../grid/ug2D.h"
#include "../grid/examples_ug2D.h"
#include "../grid/blockgrid2D.h"
#include "../grid/marker2D.h"

#include "../extemp/extemp2D.h"
#include "../extemp/co_fu2D.h"
#include "../extemp/variable2D.h"
#include "../extemp/variable2D_cc.h"

#include "../extemp/cellvar2D.h"
#include "diffop2D.h"

//
//template<>
//  void
//  Local_stiffness_matrix2D<std::complex<double> >::Print_MAT(std::ostream& Datei, std::string title) const
//  {
//    using namespace boost::numeric::ublas;
//    int i, j, k, u, v, id, num;
//    int Nx, Ny, N_total;
//
//    Unstructured2DGrid* ug = blockgrid->Give_unstructured_grid();
//    //ug->edges[i].Give_id_corner()
//    int size = 0;
//    for (id = 0; id < ug->Give_number_rectangle(); ++id) {
//      if (ug->Give_rectangle(id)->my_object(my_rank)) {
//        Nx = blockgrid->Give_Nx_rectangle(id);
//        Ny = blockgrid->Give_Ny_rectangle(id);
//        size += (Nx + 1) * (Ny + 1);
//      }
//    }
//
//    using namespace boost::numeric::ublas;
//    mapped_matrix<std::complex<double> > m(size, size, 0);
//    size = 0;
//    for (id = 0; id < ug->Give_number_rectangle(); ++id) {
//      if (ug->Give_rectangle(id)->my_object(my_rank)) {
//        Nx = blockgrid->Give_Nx_rectangle(id);
//        Ny = blockgrid->Give_Ny_rectangle(id);
//
//        N_total = Nx * Ny * 64;
//
//        for (j = 0; j < Ny; ++j) {
//          for (i = 0; i < Nx; ++i) {
//            unsigned int ids[] =
//              { Ind_loc_matrix_rectangle_BL(i, j), Ind_loc_matrix_rectangle_BR(i, j), Ind_loc_matrix_rectangle_TL(i, j), Ind_loc_matrix_rectangle_TR(
//                  i, j) };
//
//            for (u = 0; u < 4; ++u) {
////                                              std::cout <<ids[u]<<"  ";
//              for (v = 0; v < 4; ++v) {
////                                                      std::cout << " " <<ids[v]<<" " <<loc_m_rectangles[id][Ind_loc_matrix_rectangle(i,j)*16+4*u+v];
//                m(size+ids[v], size+ids[u]) += loc_m_rectangles[id][Ind_loc_matrix_rectangle(i,j) * 16 + 4 * u + v];
//              }
////                                              std::cout << endl;
//            }
//          }
//        }
//        size += (Nx + 1) * (Ny + 1);
//      }
//    }
//    mapped_matrix<std::complex<double> >::iterator1 it1;
//    mapped_matrix<std::complex<double> >::iterator2 it2;
//    Datei << "%%MatrixMarket matrix coordinate complex general" << endl;
//    Datei << "% Generated 28-Nov-2013" << endl;
//    Datei << m.size1() << "  " << m.size2() << "  " << m.nnz() << endl;
//    for (it1 = m.begin1(); it1 != m.end1(); ++it1) {
//      for (it2 = it1.begin(); it2 != it1.end(); ++it2) {
//        Datei << it2.index1() + 1 << "  " << it2.index2() + 1 << "  " << std::scientific << (*it2).real() << "  " << (*it2).imag() << std::endl;
//      }
//    }
//  }
//
//template <>
//void Local_stiffness_matrix2D<double>::Print_MAT(std::ostream& Datei, std::string title) const {
//        using namespace boost::numeric::ublas;
//        int i,j,k,u,v,id,num;
//        int Nx, Ny, N_total;
//
//        Unstructured2DGrid* ug = blockgrid->Give_unstructured_grid();
//        //ug->edges[i].Give_id_corner()
//        for(id=0;id< ug->Give_number_rectangle();++id) {
//                if(ug->Give_rectangle(id)->my_object(my_rank)) {
//                        Nx = blockgrid->Give_Nx_rectangle(id);
//                        Ny = blockgrid->Give_Ny_rectangle(id);
//                    using namespace boost::numeric::ublas;
//                    mapped_matrix<double> m ((Nx+1)*(Ny+1), (Nx+1)*(Ny+1), (Nx+1)*(Ny+1) * (Nx+1)*(Ny+1));
//
//                        N_total = Nx * Ny * 64;
//
//                        for(j=0;j<Ny;++j) {
//                                for(i=0;i<Nx;++i){
//                                        unsigned int ids[] = {Ind_loc_matrix_rectangle_BL(i,j),Ind_loc_matrix_rectangle_BR(i,j),Ind_loc_matrix_rectangle_TL(i,j),Ind_loc_matrix_rectangle_TR(i,j)};
//
//                                        for(u=0;u<4;++u) {
////                                              std::cout <<ids[u]<<"  ";
//                                                for(v=0;v<4;++v) {
////                                                      std::cout << " " <<ids[v]<<" " <<loc_m_rectangles[id][Ind_loc_matrix_rectangle(i,j)*16+4*u+v];
//                                                        m(ids[v],ids[u]) += loc_m_rectangles[id][Ind_loc_matrix_rectangle(i,j)*16+4*u+v];
//                                                }
////                                              std::cout << endl;
//                                        }
//                                }
//                        }
//                        mapped_matrix<double>::iterator1 it1;
//                        mapped_matrix<double>::iterator2 it2;
//                        Datei << "%%MatrixMarket matrix coordinate real general" <<endl;
//                        Datei << "% Generated 28-Nov-2013" <<endl;
//                        Datei << m.size1() << "  " << m.size2() << "  " << m.nnz() << endl;
//                        for(it1 = m.begin1(); it1 != m.end1(); ++it1)
//                        {
//                                for(it2 = it1.begin(); it2 != it1.end(); ++it2)
//                                {
//                                        Datei << it2.index1()+1 << "  "  << it2.index2()+1 << "  " << std::scientific << *it2 << std::endl;
//                                }
//                        }
//                }
//        }
//}
