/**********************************************************************************
 * Copyright 2013 Christoph Pflaum 
 * 		Department Informatik Lehrstuhl 10 - Systemsimulation
 *		Friedrich-Alexander Universität Erlangen-Nürnberg
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.

 **********************************************************************************/

#ifndef UGBLOCK2D_H_
#define UGBLOCK2D_H_

#ifdef _OPENMP
#include <omp.h>
#endif


#include "../../program/source/mympi.h"  // von 3D UGBlocks
#include "../../Source_Colsamm/Colsamm.h"


#include "abbrevi2D.h"
#include "math_lib/math_lib.h"
#include "math_lib/mg_array.h"
#include "grid/ug2D.h"
#include "grid/examples_ug2D.h"
#include "grid/blockgrid2D.h"
#include "grid/marker2D.h"
#include "grid/interpolation2D.h"
#include "grid/interpolation2D_cc.h"
#include "grid/flexibleInterpolation2D.h"
#include "grid/flexibleInterpolation2D_cc.h"


#include "extemp/extemp2D.h"
#include "extemp/calcArg.h"
#include "extemp/co_fu2D.h"
#include "extemp/functor2D.h"
#include "extemp/variable2D.h"
#include "extemp/variableFFT.h"
#include "extemp/variable2D_cc.h"
#include "extemp/print_var2D_vtk_cc.h"
#include "extemp/print_cellvar2D_vtk.h"

#include "extemp/cellvar2D.h"

#include "pde_op/diffop2D.h"
#include "pde_op/diffop2D_cc.h"

#include "pde_op/ressten2D.h"
#include "pde_op/ressten2D_cc.h"
#include "pde_op/mgop2D.h"
#include "interpol/interpolTwoD.h"


//#include "ugopenmp.h"


#endif // UGBLOCK2D_H_
